"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const apollo_server_core_1 = require("apollo-server-core");
const graphql_playground_html_1 = require("@apollographql/graphql-playground-html");
const http2Apollo_1 = require("./http2Apollo");
class Http2ApolloServer extends apollo_server_core_1.ApolloServerBase {
    async createGraphQLServerOptions(stream, headers) {
        return super.graphQLServerOptions({ stream, headers });
    }
    supportsSubscriptions() {
        return true;
    }
    supportsUploads() {
        return true;
    }
    applyMiddleware({ server, path }) {
        if (!path)
            path = '/graphql';
        // TODO: Health check
        // TODO: Uploads
        this.graphqlPath = path;
        server.on('stream', (stream, headers) => {
            if (headers[':path'] !== path)
                return;
            if (this.playgroundOptions && headers[':method'] === 'GET') {
                const playgroundRenderPageOptions = Object.assign({ endpoint: path, subscriptionEndpoint: this.subscriptionsPath }, this.playgroundOptions);
                const playground = graphql_playground_html_1.renderPlaygroundPage(playgroundRenderPageOptions);
                stream.respond({
                    'content-type': 'text/html'
                });
                return stream.end(playground);
            }
            http2Apollo_1.graphqlHttp2(() => this.createGraphQLServerOptions(stream, headers))(stream, headers);
        });
    }
}
exports.Http2ApolloServer = Http2ApolloServer;
//# sourceMappingURL=Http2ApolloServer.js.map