"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const apollo_server_core_1 = require("apollo-server-core");
const graphql_playground_html_1 = require("@apollographql/graphql-playground-html");
const httpApollo_1 = require("./httpApollo");
class HttpApolloServer extends apollo_server_core_1.ApolloServerBase {
    async createGraphQLServerOptions(req, res) {
        return super.graphQLServerOptions({ req, res });
    }
    supportsSubscriptions() {
        return true;
    }
    supportsUploads() {
        return true;
    }
    applyMiddleware({ server, path }) {
        if (!path)
            path = '/graphql';
        // TODO: Health check
        // TODO: Uploads
        this.graphqlPath = path;
        server.on('request', (req, res) => {
            if (req.url !== path)
                return;
            if (this.playgroundOptions && req.method === 'GET') {
                const playgroundRenderPageOptions = Object.assign({ endpoint: path, subscriptionEndpoint: this.subscriptionsPath }, this.playgroundOptions);
                res.setHeader('Content-Type', 'text/html');
                const playground = graphql_playground_html_1.renderPlaygroundPage(playgroundRenderPageOptions);
                res.write(playground);
                return res.end();
            }
            httpApollo_1.graphqlHttp(() => this.createGraphQLServerOptions(req, res))(req, res);
        });
    }
}
exports.HttpApolloServer = HttpApolloServer;
//# sourceMappingURL=HttpApolloServer.js.map